/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "color.h"


using namespace irr;


SCM
scm_from_color (video::SColor color)
{
  return scm_list_4 (scm_from_uint32 (color.getAlpha ()),
                     scm_from_uint32 (color.getRed ()),
                     scm_from_uint32 (color.getGreen ()),
                     scm_from_uint32 (color.getBlue ()));
}


video::SColor
scm_to_color (SCM color)
{
  return video::SColor
    (scm_to_uint32 (scm_car (color)),
     scm_to_uint32 (scm_cadr (color)),
     scm_to_uint32 (scm_caddr (color)),
     scm_to_uint32 (scm_cadddr (color)));
}
