/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "gui-scrollbar.h"
#include "gsubr.h"


using namespace irr;


SCM
IGUIScrollBar_getPos (SCM gui_scrollbar)
{
  return scm_from_int32
    (((gui::IGUIScrollBar*)scm_to_pointer (gui_scrollbar))->getPos ());
}


SCM
IGUIScrollBar_setMax (SCM gui_scrollbar,
                      SCM max)
{
  ((gui::IGUIScrollBar*) scm_to_pointer (gui_scrollbar))->setMax (scm_to_int32 (max));
  return SCM_UNSPECIFIED;
}


SCM
IGUIScrollBar_setPos (SCM gui_scrollbar,
                      SCM pos)
{
  ((gui::IGUIScrollBar*) scm_to_pointer (gui_scrollbar))->setPos (scm_to_int32 (pos));
  return SCM_UNSPECIFIED;
}


extern "C" {

  void
  init_gui_scrollbar (void)
  {
    DEFINE_GSUBR ("IGUIScrollBar_getPos", 1, 0, 0, IGUIScrollBar_getPos);
    DEFINE_GSUBR ("IGUIScrollBar_setMax", 2, 0, 0, IGUIScrollBar_setMax);
    DEFINE_GSUBR ("IGUIScrollBar_setPos", 2, 0, 0, IGUIScrollBar_setPos);
  }

}
