/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "position2d.h"


using namespace irr;


SCM
scm_from_position2d_s32 (core::position2d<s32> position2d)
{
  return scm_list_2 (scm_from_int32 (position2d.X),
                     scm_from_int32 (position2d.Y));
}

core::position2d<f32>
scm_to_position2d_f32 (SCM position2d)
{
  return core::position2d<f32>
    (scm_to_double (scm_car (position2d)),
     scm_to_double (scm_cadr (position2d)));
}

core::position2d<s32>
scm_to_position2d_s32 (SCM position2d)
{
  return core::position2d<s32>
    (scm_to_int32 (scm_car (position2d)),
     scm_to_int32 (scm_cadr (position2d)));
}
