/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <libguile.h>
#include <wchar.h>
#include "wchar.h"

SCM
scm_from_wide_char_string (const wchar_t* wtext)
{
  size_t nbytes = wcslen (wtext) + 1;
  char* ctext = (char*)malloc (nbytes);
  wcstombs (ctext, wtext, nbytes);
  return scm_from_utf8_string (ctext);
}

const wchar_t*
scm_to_wide_char_string (SCM text)
{
  char* ctext = scm_to_utf8_stringn (text, NULL);
  wchar_t* wtext = (wchar_t*)malloc ((strlen (ctext) + 1) * sizeof (wchar_t));
  mbstowcs (wtext, ctext, strlen (ctext) + 1);
  return wtext;
}
